// Copyright (C) 2022 RozK
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU Affero General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU Affero General Public License for more details.
//
// You should have received a copy of the GNU Affero General Public License
// along with this program.  If not, see <http://www.gnu.org/licenses/>.

#ifndef _RK_ENGINE_DISPLAY_GLX_H
#define _RK_ENGINE_DISPLAY_GLX_H

#include "../types.hpp"
#include "display_x11.hpp"
#include "../events/events_x11.hpp"
#include <GL/glx.h>

struct rk_display_glx : public rk_display_x11 {
    GLXContext context;
};

typedef void (*rk_DrawElementsInstancedBaseInstanceFunc)(rk_uint, rk_uint, rk_uint, const void *, rk_uint, rk_uint);
typedef void (*rk_MultiDrawElementsIndirectFunc)(rk_uint, rk_uint, const void *, rk_uint, rk_uint);

extern rk_DrawElementsInstancedBaseInstanceFunc rk_DrawElementsInstancedBaseInstance;
extern rk_MultiDrawElementsIndirectFunc rk_MultiDrawElementsIndirect;

#endif // _RK_ENGINE_DISPLAY_GLX_H
